<?php

declare(strict_types=1);

namespace App\Repository;

final class TblAyudaRepository
{
    private \PDO $database;

    public function __construct(\PDO $database)
    {
        $this->database = $database;
    }

    public function getDb(): \PDO
    {
        return $this->database;
    }

    public function checkAndGet(int $TblAyudaId): object
    {
        $query = 'SELECT * FROM `TblAyuda` WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblAyudaId);
        $statement->execute();
        $TblAyuda = $statement->fetchObject();
        if (! $TblAyuda) {
            throw new \Exception('TblAyuda not found.', 404);
        }

        return $TblAyuda;
    }

    public function getAll(): array
    {
        $query = 'SELECT * FROM `TblAyuda` ORDER BY `id`';
        $statement = $this->getDb()->prepare($query);
        $statement->execute();

        return (array) $statement->fetchAll();
    }

    public function create(object $TblAyuda): object
    {
        $query = 'INSERT INTO `TblAyuda` (`Ayuda`, `Imagen`, `IdPregunta`, `field1`, `field2`, `field3`, `field4`, `field5`) VALUES (:Ayuda, :Imagen, :IdPregunta, :field1, :field2, :field3, :field4, :field5)';
        $statement = $this->getDb()->prepare($query);
//         $statement->bindParam('id', $TblAyuda->id);
//         $statement->bindParam('fecha', $TblAyuda->fecha);
        $statement->bindParam('Ayuda', $TblAyuda->Ayuda);
        $statement->bindParam('Imagen', $TblAyuda->Imagen);
        $statement->bindParam('IdPregunta', $TblAyuda->IdPregunta);
        $statement->bindParam('field1', $TblAyuda->field1);
        $statement->bindParam('field2', $TblAyuda->field2);
        $statement->bindParam('field3', $TblAyuda->field3);
        $statement->bindParam('field4', $TblAyuda->field4);
        $statement->bindParam('field5', $TblAyuda->field5);

        $statement->execute();

        return $this->checkAndGet((int) $this->getDb()->lastInsertId());
    }

    public function update(object $TblAyuda, object $data): object
    {
        if (isset($data->fecha)) {
            $TblAyuda->fecha = $data->fecha;
        }
        if (isset($data->Ayuda)) {
            $TblAyuda->Ayuda = $data->Ayuda;
        }
        if (isset($data->Imagen)) {
            $TblAyuda->Imagen = $data->Imagen;
        }
        if (isset($data->IdPregunta)) {
            $TblAyuda->IdPregunta = $data->IdPregunta;
        }
        if (isset($data->field1)) {
            $TblAyuda->field1 = $data->field1;
        }
        if (isset($data->field2)) {
            $TblAyuda->field2 = $data->field2;
        }
        if (isset($data->field3)) {
            $TblAyuda->field3 = $data->field3;
        }
        if (isset($data->field4)) {
            $TblAyuda->field4 = $data->field4;
        }
        if (isset($data->field5)) {
            $TblAyuda->field5 = $data->field5;
        }

        $query = 'UPDATE `TblAyuda` SET `fecha` = :fecha, `Ayuda` = :Ayuda, `Imagen` = :Imagen, `IdPregunta` = :IdPregunta, `field1` = :field1, `field2` = :field2, `field3` = :field3, `field4` = :field4, `field5` = :field5 WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblAyuda->id);
        $statement->bindParam('fecha', $TblAyuda->fecha);
        $statement->bindParam('Ayuda', $TblAyuda->Ayuda);
        $statement->bindParam('Imagen', $TblAyuda->Imagen);
        $statement->bindParam('IdPregunta', $TblAyuda->IdPregunta);
        $statement->bindParam('field1', $TblAyuda->field1);
        $statement->bindParam('field2', $TblAyuda->field2);
        $statement->bindParam('field3', $TblAyuda->field3);
        $statement->bindParam('field4', $TblAyuda->field4);
        $statement->bindParam('field5', $TblAyuda->field5);

        $statement->execute();

        return $this->checkAndGet((int) $TblAyuda->id);
    }

    public function delete(int $TblAyudaId): void
    {
        $query = 'DELETE FROM `TblAyuda` WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblAyudaId);
        $statement->execute();
    }
}
